if inGame() and isPlaying() then
   function markEnemies()
      if not toggleMark then return end
      -- MARK CAMERAS
      if isHost() then
         for u_key, u_data in pairs( managers.groupai:state()._security_cameras ) do
            if u_data.contour then u_data:contour():add( "mark_unit" ) end
         end
      else
         for _, unit in ipairs( SecurityCamera.cameras ) do
            if unit and unit:contour() and unit:enabled() and unit:base() and not unit:base():destroyed() then
               unit:contour():add( "mark_unit" )
            end
         end
      end
      -- MARK ENEMIES
      for u_key,u_data in pairs(managers.enemy:all_enemies()) do
         if u_data.unit.contour and alive(u_data.unit) then
            u_data.unit:contour():add( "mark_enemy" )
         end
      end
      -- MARK CIVS
      for u_key,u_data in pairs(managers.enemy:all_civilians()) do
         if u_data.unit.contour and alive(u_data.unit) and not isHostage(u_data.unit) then
            u_data.unit:contour():add( "mark_enemy" )
         end
      end
   end
 
   function UnitNetworkHandler:mark_enemy( unit, marking_strength, sender )
   end
 
   if GameSetup then
      if not _gameUpdate then _gameUpdate = GameSetup.update end
      local _gameUpdateLastMark
      function GameSetup:update(t, dt)
         _gameUpdate(self, t, dt)
         if not _gameUpdateLastMark or t - _gameUpdateLastMark > 4 then
            _gameUpdateLastMark = t
            markData()
         end
      end
   end
 
   function markData()
      markEnemies()
   end
 
   function markClear()
      if not inGame() then return end
      for u_key, u_data in pairs(managers.groupai:state()._security_cameras) do
         if u_data.contour then u_data:contour():remove( "mark_unit" ) end
      end
      for u_key,u_data in pairs(managers.enemy:all_enemies()) do
         if u_data.unit.contour then u_data.unit:contour():remove( "mark_enemy" ) end
      end
      for u_key,u_data in pairs(managers.enemy:all_civilians()) do
         if u_data.unit.contour then u_data.unit:contour():remove( "mark_enemy" ) end
      end
   end
 
   function markToggle(toggleSync)
      if not inGame() then return end
      if toggleSync then
         syncMark = not syncMark
      else
         toggleMark = not toggleMark
         if not toggleMark then markClear() end
      end
      markData()
   end
 
   if not toggleMark then toggleMark = false end
   if not syncMark then syncMark = false end
   markToggle()
 
else
end